package de.uni_marburg.powersort.sort;

import de.uni_marburg.powersort.JUnitUtil;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.converter.ConvertWith;
import org.junit.jupiter.params.provider.CsvSource;

import static org.junit.jupiter.api.Assertions.assertArrayEquals;

public abstract class AbstractSortTest {
    SortEnum sortAlg;

    @ParameterizedTest
    @CsvSource({
            "'',''",
            "'1337','1337'",
            "'3|2|1','1|2|3'",
            "'1|1','1|1'",
            "'2|1','1|2'",
            "'2|1|2','1|2|2'",
    })
    void test1(@ConvertWith(JUnitUtil.IntegerArrayConverter.class) Integer[] array, @ConvertWith(JUnitUtil.IntegerArrayConverter.class) Integer[] expected) {
        sortAlg.get().sort(array);
        assertArrayEquals(expected, array);
    }
}
